<template>
  <div style="margin-top: 60px" class="content-grid content-grid--subpage content-grid--subpage-table">  
    <h1 class="back-link-title">{{ t(`routes.admin.children.consulter-grille-cours.name`) }}</h1>

    <div class="content-grid__header">
      <h2 class="back-link-title">Cours</h2>
      <div class="content-grid__filters">
        <SearchInput v-model="searchValue"/>
      </div>
    </div>
    <Card>
      <DataTable
          :headers="coursHeader"
          :items="tableCours"
          :search-value="searchValue"
          @delete="deleteCours"
          @click="handleRowClick"
      />
    </Card>
    <TableauGrilles/>
  </div>
</template>
<script lang="ts" setup>
import { useI18n } from "vue3-i18n";
import { computed, onMounted, ref } from "vue";
import { useCoursService, useGrilleService } from "@/inversify.config";
import { notifyError, notifySuccess } from "@/notify";
import Card from "@/components/layout/Card.vue";
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
import DataTable from "@/components/layout/DataTable.vue";
import { Cours } from "@/types/entities/cours";
import SearchInput from "@/components/layout/SearchInput.vue";
import { Grille } from "../../types/entities/creation-grille/Grille";
import TableauGrilles from "@/components/grilles/TableauGrilles.vue";

const { t } = useI18n();
const allCours = ref<Cours[]>([]);
const coursService = useCoursService();
const searchValue = ref("");

const tableCours = computed(() => {
  console.log("AllCours",allCours.value)
  return allCours.value
      .map((x: Cours) => {
        return {
          id: x.id,
          code: x.code,
          nomCours: x.nomCours,
          nomProfesseur: x.membre?.firstName + " " + x.membre?.lastName,
          actions: {
            update: {
              path: `/fr/cours/${x.id}/modifier`,
              params: { id: x.id },
            },
            delete: true,
            view: {
              path: `/fr/cours/${x.id}/details`,
              params: {
                id: x.id,
              },
            },
          },
        };
      })
      .sort((a: any, b: any) => {
        if (a.name < b.name) {
          return -1;
        }
        if (a.name > b.name) {
          return 1;
        }
        return 0;
      }) as unknown as Cours[];
});
onMounted(async () => {
  await loeadAllCours();
});

async function loeadAllCours() {
  let cours = await coursService.getAllCours();
  if (cours && cours.length > 0) allCours.value = cours;
}

async function deleteCours(cours: Cours) {
  if (cours.id == null) return;
  let confirmation = confirm(t("validation.cours.delete.confirmation"));
  if (!confirmation) return;
  let response = await coursService.deleteCours(cours.id);
  if (response.succeeded) {
    allCours.value = allCours.value.filter((x) => x.id !== cours.id);
    notifySuccess(t("validation.cours.delete.success"));
  } else {
    let errorMessages = response.getErrorMessages(
        "validation.cours.delete.confirmation",
        "validation.cours.delete.errorOccured"
    );
    notifyError(errorMessages[0]);
  }
    }

    const handleRowClick = (e: any) => {
        e.target.parentNode.getElementsByTagName('a')[0].click()
    }
const coursHeader = [
  {
    text: "Code",
    value: "code",
    sortable: true,
    width: 300,
  },
  {
    text: "Nom Cours",
    value: "nomCours",
    sortable: true,
    width: 150,
  },
  {
    text: "Nom du professeur",
    value: "nomProfesseur",
    sortable: true,
    width: 150,
  },
  {
    text: "",
    value: "actions",
    width: 75,
  },
];
</script>
